VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Text Editor"
   ClientHeight    =   3495
   ClientLeft      =   3000
   ClientTop       =   2880
   ClientWidth     =   6570
   LinkTopic       =   "Form1"
   ScaleHeight     =   3495
   ScaleWidth      =   6570
   Begin MSComDlg.CommonDialog cdMain 
      Left            =   3000
      Top             =   1560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.TextBox txtMain 
      Height          =   1575
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu itmNew 
         Caption         =   "&New"
      End
      Begin VB.Menu itmOpen 
         Caption         =   "&Open..."
      End
      Begin VB.Menu itmSave 
         Caption         =   "&Save..."
         Shortcut        =   ^S
      End
      Begin VB.Menu sepOne 
         Caption         =   "-"
      End
      Begin VB.Menu itmSettings 
         Caption         =   "Se&ttings"
         Begin VB.Menu itmBlackOnWhite 
            Caption         =   "Black on White"
            Checked         =   -1  'True
         End
         Begin VB.Menu itmWhiteOnBlack 
            Caption         =   "White on Black"
         End
      End
      Begin VB.Menu itmAbout 
         Caption         =   "&About..."
      End
      Begin VB.Menu sepTwo 
         Caption         =   "-"
      End
      Begin VB.Menu itmExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu itmUndo 
         Caption         =   "&Undo"
         Shortcut        =   ^Z
      End
      Begin VB.Menu sepThree 
         Caption         =   "-"
      End
      Begin VB.Menu itmCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu itmPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu sepFour 
         Caption         =   "-"
      End
      Begin VB.Menu itmSelectAll 
         Caption         =   "Select &All"
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public gfUndoBuffer$    'Global variable to hold undo string
Public gfCursorPos%     'Current position of cusor in string

Private Sub Form_Load()
    frmMain.Caption = "Text Editor- [New Document]"
End Sub

Private Sub Form_Resize()
    txtMain.Top = 0
    txtMain.Left = 0
    txtMain.Width = ScaleWidth
    txtMain.Height = ScaleHeight
End Sub

Private Sub itmAbout_Click()
    Dim Msg$
    
    Msg$ = "Text Editor" & vbCrLf
    Msg$ = Msg$ & "By Bob Reselman" & vbCrLf
    Msg$ = Msg$ & Chr$(169) & " Macmillan Publishing "

    MsgBox Msg$, vbOKOnly, "About"
End Sub

Private Sub itmBlackOnWhite_Click()
    txtMain.BackColor = vbWhite
    txtMain.ForeColor = vbBlack
    itmBlackOnWhite.Checked = True
    itmWhiteOnBlack.Checked = False
    
End Sub

Private Sub itmCut_Click()
    Dim strLeft As String   'Variable to hold text from left of cursor
    Dim strRight As String  'Variable to hold text from right of cusort
    Dim strFull As String   'Full text
    
    'Get the position of the cursor within the
    'text box
    gfCursorPos% = txtMain.SelStart
    'Get all the text within the text box
    strFull = txtMain.Text
    
    'Determine the text on the left side fo the cursor
    strLeft = Left(strFull, gfCursorPos%)
    
    'Determine the text on the right side of the cursor excluding
    'the selected text.
    strRight = Right(strFull, Len(strFull) - (gfCursorPos% + txtMain.SelLength))
    
    'Send the selected text to the clipboard
    Clipboard.SetText (txtMain.SelText)
    
    'Send the existing text to an Undo buffer
    gfUndoBuffer$ = txtMain.Text
    
    '"Cut" the selected text out of the text in the text box.
    'The construct a new string with the remaining text.
    txtMain.Text = strLeft & strRight
    
    'Set the curor to the cut point
    txtMain.SelStart = gfCursorPos%
End Sub

Private Sub itmExit_Click()
    Dim Msg$
    
    Msg$ = "Are you sure you want to quit?"
    
    If MsgBox(Msg$, vbYesNo + vbQuestion, _
            "Exiting Text Editor") = vbYes Then
        End
    End If
End Sub

Public Sub NoImplement()
    '****************************************
    'Sub/Function: NoImplement
    '
    'Variables: None
    '
    'Return: None
    '
    'Remarks:   This sub shows a message box informing the
    '           user that an intended feature is not implemented
    '
    'Programmer: Bob Reselman
    '
    'History: Created 8/5/97
    '
    'Copyright 1997, Macmillan Publishers
    '****************************************
    MsgBox "Not Implemented", vbInformation
End Sub

Private Sub itmNew_Click()
    'Ask the user if s/he wants to save this work
    If MsgBox("Do you want to save this document", vbQuestion + _
                    vbYesNo, "Save File?") = vbYes Then
        'If Yes, call the event procedure for the Save menu item.
        Call itmSave_Click
    End If
    'Clean out the text box
    txtMain.Text = ""
    
    'Report that this is a new document in the form's caption
    frmMain.Caption = "Text Editor- [New Document]"
End Sub

Private Sub itmOpen_Click()
    Dim strFileName As String   'String of file to open
    Dim strText As String       'Contents of file
    Dim strFilter As String     'Common Dialog filter string
    Dim strBuffer As String     'String buffer variable
    Dim FileHandle%             'Variable to hold file handle
    
    'Set the Common Dialog filter
    strFilter = "Text (*.txt)|*.txt|All Files (*.*)|*.*"
    cdMain.Filter = strFilter
    
    'Open the common dialog
    cdMain.ShowOpen
    
    
    'Make sure the retrieved filename is not a blank string
    If cdMain.filename <> "" Then
        
        'If it is not blank open the file
        strFileName = cdMain.filename
        
        'Get a free file handle and assign it to the file handle variable
        FileHandle% = FreeFile
        
        'Open the file
        Open strFileName For Input As #FileHandle%
        
        'Make the mouse cursor an hourglass
        MousePointer = vbHourglass
        
        'Traverse the lines of the file
        Do While Not EOF(FileHandle%) ' Check for end of file.
            
            'Read a line of the file
            Line Input #FileHandle%, strBuffer    ' Read line of data.
            
            'Add the line from the output buffer to the text string
            strText = strText & strBuffer & vbCrLf
        Loop
        
        'Change the mousepointer back to the arrow
        MousePointer = vbDefault
        
        'Close the file once you have had your way with it
        Close #FileHandle%
        
        'Assign the retrieved text to the text box
        txtMain.Text = strText
        
        'Put the file name in the form caption
        frmMain.Caption = "Text Editor- [" & strFileName & "]"
    End If
End Sub

Private Sub itmPaste_Click()
    Dim Temp$               'Text from clipboard
    Dim strLeft As String   'Variable to hold text from left of cursor
    Dim strRight As String  'Variable to hold text from right of cusort
    Dim strFull As String   'Full text
    
    'Get the text from the clipboard
    Temp$ = Clipboard.GetText(vbCFText)
    'Get the position of the cursor within the
    'text box
    gfCursorPos% = txtMain.SelStart
    'Get all the text within the text box
    strFull = txtMain.Text
    
    'Determine the text on the left side fo the cursor
    strLeft = Left(strFull, gfCursorPos%)
    
    'Determine the text on the right side of the cursor excluding
    'the selected text.
    strRight = Right(strFull, Len(strFull) - (gfCursorPos% + txtMain.SelLength))
    
    'Send the existing text to an Undo buffer
    gfUndoBuffer$ = txtMain.Text
    
    '"Paste" the selected text into the text in the text box.
    txtMain.Text = strLeft & Temp$ & strRight
    
    'Set the curor to the paste point
    gfCursorPos% = Len(strLeft & Temp$)
    
    txtMain.SelStart = gfCursorPos%
End Sub

Private Sub itmSave_Click()
    Dim strFileName As String   'String of file to open
    Dim strText As String       'Contents of file
    Dim strFilter As String     'Common Dialog filter string
    Dim strBuffer As String     'String buffer variable
    Dim FileHandle%             'Variable to hold file handle
    
    'Set the Common Dialog filter
    strFilter = "Text (*.txt)|*.txt|All Files (*.*)|*.*"
    cdMain.Filter = strFilter
    
    'Open the common dialog in save mode
    cdMain.ShowSave
    
    'Make sure the retrieved filename is not a blank string
    If cdMain.filename <> "" Then
        'If it is not blank open the file
        strFileName = cdMain.filename
        
        'Assign a value to the text variable
        strText = txtMain.Text
        
        'Get a free file handle and assign it to the file handle variable
        FileHandle% = FreeFile
        
        'Open a file for writing
        Open strFileName For Output As #FileHandle%
        
        'Set an hour glass cursor just in case it takes a while
        MousePointer = vbHourglass
        
        'Do the write
        Print #FileHandle%, strText
        
        'Reset the cursor to the Windows default.
        MousePointer = vbDefault
        
        'Close the file once you have had your way with it
        Close #FileHandle%
    End If
    
End Sub


Private Sub itmSelectAll_Click()
    txtMain.SelStart = 0
    txtMain.SelLength = Len(txtMain.Text)
End Sub

Private Sub itmUndo_Click()
    txtMain.Text = gfUndoBuffer$
    
    'Set the curor to the cut point
    txtMain.SelStart = gfCursorPos%
End Sub

Private Sub itmWhiteOnBlack_Click()
    txtMain.BackColor = vbBlack
    txtMain.ForeColor = vbWhite
    itmBlackOnWhite.Checked = False
    itmWhiteOnBlack.Checked = True
End Sub

Private Sub mnuCopy_Click()
    Clipboard.SetText txtMain.SelText
End Sub
