VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "File System Stuff"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtData 
      Height          =   2775
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   240
      Width           =   2775
   End
   Begin MSComDlg.CommonDialog cdlgMain 
      Left            =   3840
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu itmNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu itmOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu itmSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save &As"
      End
      Begin VB.Menu itmSep 
         Caption         =   "-"
      End
      Begin VB.Menu itmFileStats 
         Caption         =   "File Statistics..."
      End
      Begin VB.Menu itmSep2 
         Caption         =   "-"
      End
      Begin VB.Menu itmExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public gf_strOpenFile As String

Private Sub Form_Resize()
    With txtData
        .Width = ScaleWidth
        .Height = ScaleHeight
        .Top = ScaleTop
        .Left = ScaleLeft
    End With
End Sub

Private Sub itmExit_Click()
    End
End Sub

Private Sub itmFileStats_Click()
    Dim fso As New FileSystemObject
    Dim ts As TextStream
    Dim fil As File
    Dim strData As String
    
    If gf_strOpenFile <> "" Then
        'Get a file
        Set fil = fso.GetFile(gf_strOpenFile)
        'Get the file name
        strData = "Name: " & fil.Name & vbCrLf
        'Get the date created
        strData = strData & "Created: " & fil.DateCreated & vbCrLf
        'Get the date last modified
        strData = strData & "Modifed: " & fil.DateLastModified & vbCrLf
        'Get the date last accessed
        strData = strData & "Last Access: " & fil.DateLastAccessed & vbCrLf
        'Get the size in bytes
        strData = strData & "Size: " & CStr(fil.Size) & " characters" & vbCrLf
        'Get the file type
        strData = strData & "Type: " & fil.Type & vbCrLf
        'Get the parent folder
        strData = strData & "Parent: " & fil.ParentFolder.Name & vbCrLf
        'Get the file path
        strData = strData & "Path: " & fil.Path & vbCrLf
        'Report the findings
        MsgBox strData, vbInformation, "File Statistics"
    Else
        MsgBox "No file selected. Please select a file!", _
            vbCritical, "File Access Error"
    End If
    
    
    
End Sub

Private Sub itmNew_Click()
    Dim strMsg As String
    Dim strData As String
    Dim fso As New FileSystemObject
    Dim ts As TextStream
    Dim fil As File
    
    strMsg = "Do you want to save this data?"
 
    If MsgBox(strMsg, vbQuestion + vbYesNo, "Save File?") = vbYes Then
        If gf_strOpenFile <> "" Then
            Set fil = fso.GetFile(gf_strOpenFile)
            Set ts = fil.OpenAsTextStream(ForWriting, TristateUseDefault)
            strData = txtData.Text
            ts.Write (strData)
            ts.Close
            gf_strOpenFile = ""
        Else
            cdlgMain.Filter = "Text (*.txt)|*.txt"
            cdlgMain.ShowSave
            gf_strOpenFile = cdlgMain.FileName
            Set ts = fso.CreateTextFile(gf_strOpenFile, True)
            strData = txtData.Text
            ts.Write (strData)
            ts.Close
            gf_strOpenFile = ""
        End If
    End If
    txtData.Text = ""
End Sub

Private Sub itmOpen_Click()
    Dim fso As New FileSystemObject
    Dim ts As TextStream
    Dim strData As String
    
    'Set a common dialog filter to show only
    'text files
    cdlgMain.Filter = "Text (*.txt)|*.txt"
    
    'Open the common dialog in Show Open mode
    cdlgMain.ShowOpen
    gf_strOpenFile = cdlgMain.FileName
    
    'Get a Text Stream Object using the
    'OpenTextFile method of the FileSystemObject
    Set ts = fso.OpenTextFile(gf_strOpenFile)
    
    'Traverse to the end of the TextStream
    'concatenating the contents onto a string
    'buffer variable.
    Do While ts.AtEndOfStream <> True
        strData = strData & ts.Read(1)
    Loop
    
    'Close the TextStream
    ts.Close
    
    'Assign the contents of the string buffer
    'to the Text property of a TextBox.
    txtData.Text = strData
End Sub

Private Sub itmSave_Click()
    Dim fso As New FileSystemObject
    Dim fil As File
    Dim ts As TextStream
    Dim strData As String
    
    'If the global file name variable is not
    'NULL than there is a filename being considered
    If gf_strOpenFile <> "" Then
            'Open a file to the filename
            Set fil = fso.GetFile(gf_strOpenFile)
            'Opem a TextStream Object for writing
            Set ts = fil.OpenAsTextStream(ForWriting, TristateUseDefault)
            'Get the text to write to the file from
            'the Text property of the TextBox
            strData = txtData.Text
            'Do the write
            ts.Write (strData)
            'Close the TextStream
            ts.Close
            'Empty the filename buffer
            gf_strOpenFile = ""
        Else
            'Set a common dialog filter for text
            cdlgMain.Filter = "Text (*.txt)|*.txt"
            'Open a save dialog
            cdlgMain.ShowSave
            'Get a filename for saving the data
            gf_strOpenFile = cdlgMain.FileName
            'Create a TextStream objet to the
            'filename
            Set ts = fso.CreateTextFile(gf_strOpenFile, True)
            'Get the text to write to the file from
            'the Text property of the TextBox
            strData = txtData.Text
            'Do the write
            ts.Write (strData)
            'Close the TextSteam
            ts.Close
        End If
        frmMain.Caption = gf_strOpenFile
End Sub

Private Sub mnuSaveAs_Click()
    Dim fso As New FileSystemObject
    Dim ts As TextStream
    Dim strData As String
    Dim fil As File
            
    cdlgMain.Filter = "Text (*.txt)|*.txt"
    cdlgMain.ShowSave
    If gf_strOpenFile = cdlgMain.FileName Then
        strData = "You have selected the present file."
        strData = strData & vbCrLf & vbCrLf
        strData = strData & "Do you really want to "
        strData = strData & "overwrite the file: " & gf_strOpenFile
        If MsgBox(strData, vbQuestion + vbYesNo, "File Overwrite") _
            = vbYes Then
            Set fil = fso.GetFile(gf_strOpenFile)
            Set ts = fil.OpenAsTextStream(ForWriting, TristateUseDefault)
            strData = txtData.Text
            ts.Write (strData)
            ts.Close
        Else
            cdlgMain.ShowSave
            gf_strOpenFile = cdlgMain.FileName
            Set ts = fso.CreateTextFile(gf_strOpenFile, True)
            strData = txtData.Text
            ts.Write (strData)
            ts.Close
        End If
    End If
        frmMain.Caption = gf_strOpenFile
End Sub
