Attribute VB_Name = "modAPIStuff"
Option Explicit
'API Constants
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
Public Const LB_ITEMFROMPOINT = &H1A9

Public Const WM_NCLBUTTONDOWN = &HA1
Public Const HTCAPTION = 2

Public Type POINTAPI
        X As Long
        Y As Long
End Type

Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public Declare Function SendMessage _
  Lib "user32" Alias "SendMessageA" _
  (ByVal hwnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    lParam As Any) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long






Public Function SetWinPos(iPos As Integer, lHWnd As Long) As Boolean
    '**********************************************************
    'Function: SetWinPos
    '
    'Arguments: iPos    An integer that denotes the
    '                   the topmost position of
    '                   the form.
    '                   0 = No top most (normal)
    '                   1 = Always on top
    '
    'lHwnd              The handle of the window to affect
    '
    'Return:            True, if successful
    '
    'Remarks:           The function is a wrapper for
    '                   the SetWindowPos API call
    '
    'Programmer:        Bob Reselman
    'History            Created 4/24/98
    'Copyright          1998 Macmillan Publisher
    '**********************************************************

    Dim lWinPos As Long 'A variable to hold the
                        'the value of API window
                        'position constant
    Dim l As Long
    
    'Use a SELECT CASE to set the value of the of
    'the API Window constant
    
    Select Case iPos
        'The window is to set to it regular position
        Case 0
            lWinPos = HWND_NOTOPMOST
        'Set the window always on top
        Case 1
            lWinPos = HWND_TOPMOST
        'You have a bad value, leave the function
        Case Else
            Exit Function
    End Select
    
    'Run the API SetWindowPos function
    If SetWindowPos(lHWnd, lWinPos, 0, 0, 0, 0, SWP_NOMOVE _
                                    + SWP_NOSIZE) Then
        'If the function is greater than 0 (FALSE) then
        'the operation was successful. Return a True for
        'to indicate such.
        SetWinPos = True
    End If
End Function

Public Function ReportMousePos() As String
    '**********************************************************
    'Function:  ReportMousePos
    '
    'Arguments: None
    '
    '
    'Return:    A string the reports the position
    '           of the mouse cursor on the screen
    '
    'Remarks:   The function is a wrapper for
    '           the GetCursorPos API call
    '
    'Programmer: Bob Reselman
    'History    Created 4/24/98
    'Copyright  1998 Macmillan Publisher
    '**********************************************************

    Dim MyPointAPI As POINTAPI  'The Windows type into
                                'which the mouse position
                                'coordinates are stored
    Dim l As Long   'Variable that hold the return value
                    'of the API function
    Dim strReport As String 'String that stores the
                            'information to be passed
                            'out of the function
    'Call the API function
    l = GetCursorPos(MyPointAPI)
    'Make a report string
    strReport = "X=" & CStr(MyPointAPI.X) & ", "
    strReport = strReport & "Y= " & CStr(MyPointAPI.Y)
    'Return the value of the report string
    If l > 0 Then
        ReportMousePos = strReport
    Else
        ReportMousePos = "Error"
    End If
End Function


Public Sub FillListBox(lst As ListBox)
'**********************************************************
    'Sub: FillListBox
    '
    'Arguments: lst as Listbox    The Listbox to fill
    '
    '
    'Return:    None
    '
    'Remarks:   The sub is fills a ListBox with some
    '           dummy data for demonstration purposes
    '
    'Programmer: Bob Reselman
    'History    Created 4/24/98
    'Copyright  1998 Macmillan Publisher
    '**********************************************************
    Dim str As String   'String buffer variable
    Dim j As Integer    'Integer to hold a random value
    Dim i As Integer    'Counter variable
    
    'Get a random value for i
    Randomize
    j = Int((20 * Rnd) + 1)
    'Empty our the list box from the last invocation
    lst.Clear
    'Add as many lines as is the value of j to
    'the ListBox
    For i = 0 To j
      str = ""
      str = "I am a very long line and my value is: " _
          & CStr(i%)
      lst.AddItem str
    Next i%
End Sub
